### 前缀映射，后缀映射和缓存映射

* 通过 `engine.NewPrefixMapper(SnakeMapper{}, "prefix")` 可以创建一个在SnakeMapper的基础上在命名中添加统一的前缀，当然也可以把SnakeMapper{}换成SameMapper或者你自定义的Mapper。

* 通过 `engine.NewSufffixMapper(SnakeMapper{}, "suffix")` 可以创建一个在SnakeMapper的基础上在命名中添加统一的后缀，当然也可以把SnakeMapper换成SameMapper或者你自定义的Mapper。

* 通过 `engine.NewCacheMapper(SnakeMapper{})` 可以创建一个组合了其它的映射规则，起到在内存中缓存曾经映射过的命名映射。

例如，如果希望所有的表名都在结构体自动命名的基础上加一个前缀而字段名不加前缀，则可以在engine创建完成后执行以下语句：

```Go
tbMapper := engine.NewPrefixMapper(SnakeMapper{}, "prefix")
engine.SetTableMapper(tbMapper)
```

执行之后，结构体 `type User struct` 默认对应的表名就变成了 `prefix_user` 了，而默认是 `user`